
;*********   4- *********** 
;*
;*  AVR ATtiny2313A,   8,0 
;*   DS18B20
;*
;* ; 
;*
;* Main:    
;* TIMER0_OVF:     0,  
;* Thermometer:     DS18B20 (1 )
;* Termometr:         DS18B20
;* Thermometer1:    DS18B20 (2 )
;* ConvTemp:       
;* ReadTemp:      
;* SignTemp:      
;* ConvByte:       , DS18B20
;* ConvByteD:          
;* CalcTemp:        
;* MUL42:         
;* DIV42:         
;* HexBCD:	     xx (Hex) -> 0abc (BCD),  - 
;* Microlan:       1-Wire
;* SYMBOL:           
;* ConvSegm:          
;* Code_8:             
;* Code_8_2:             . 
;* 
;* FUSES;        CKSEL=0100, SUT1=1, SUT0=0, SPIEN=0, VDTON=0
;*************************************************************************

.nolist
.include "tn2313def.inc"
.list

;*****  *****

.def   m0  = r1 
.def   m1  = r2
.def   m2  = r3
.def   m3  = r4 
.def   m4  = r5
.def   m5  = r6
.def   m6  = r7
.def   m7  = r8

.def	Save = r12     ;   SREG  
.def   hexL  = r14     ;   16- 
.def   hexH  = r15     ;   16- 
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	Interm = r18   ;  
.def	Ndisp =  r19   ;   
.def	BCD0  = r20    ;   - 
.def	tim1 = r21     ;   
.def    Cnt = r22      ;  
             

;*****   *****

.equ	Interval= 152   ;    300 
.equ    DQ =  PA0       ; DQ =  A,  1-Wire (1 )
.equ    DQ1 =  PA1      ; DQ1 =  A,  1-Wire (2 )
.equ    T1D =  3        ;   , 2,0*T1D 

.cseg

.org 0
    rjmp Initial
     
.org 6                   ;    T0, 
	rjmp TIMER0_OVF      
    
Initial:	
	
	ldi	t1,(RAMEND)	    ;  
	out	SPL,t1

	ldi	t1,0
	out	PORTA,t1        ; PA0=PA1-
	out	DDRA,t1	

   	ldi	t1,0b11111111  
	out	PORTB,t1        ; PB0-PB7-
	ldi	t1,0b11111111		
	out	DDRB,t1			;   
 		    ; 
    ldi	t1,0b01000000  
	out	PORTD,t1        ; PD0=PD3-,PD6-   
	ldi	t1,0b00001111		
	out	DDRD,t1			;     

    ldi t1,(1<<TOIE0)   ;     T0
    out TIMSK,t1         
	ldi t1,(1<<CS02)    ;     256  T0
    out TCCR0B,t1       ;    8000000/256 = 31250 Hz 
    ldi t1,Interval     ;  
    out TCNT0,t1 
         
	ldi t1,(1<<CS12);   256  T1
    out TCCR1B,t1       ;    8000000/256 = 31250 Hz 

clr Ndisp  			;  
ldi Interm,0b01000000 ;  PD6  

ldi t1,11			;      ""	 
sts SW0,t1
sts SW1,t1
sts SW2,t1
sts SW3,t1
rcall Code_8        ;       
sei

;*********************************************************************************
Main: ;   

rcall Thermometer    ;    DS18B20
rcall Termometr      ;      DS18B20
rcall Time2S         ;   5 
sbis PIND,6		     ;   ?
rjmp Main            ;  ,  
rcall Thermometer1   ;    DS18B20
rcall Termometr      ;      DS18B20
rcall Time2S         ;   5 
rjmp Main


Time2S: ;     2,0 

ldi   t1,high(0)  
out TCNT1H,t1		;  ,(TCNT1H)
ldi   t1,low(0)   
out TCNT1L,t1		;  ,(TCNT1L)
ldi   t1,1<<TOV1	;     TOV1
out   TIFR,t1	    ;   TOV1
ldi   tim1,T1D	    ; T1D   
Wait:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV1	    ;   ,   - 
rjmp  Wait	        ;   
ldi   t1,1<<TOV1	;     TOV1
out   TIFR,t1    	;   TOV1
dec   tim1
brne  Wait	        ; 1  = 2,0 
ret

Time1S: ;   1,0 

ldi   t1,high(32768)  
out TCNT1H,t1		;  ,(TCNT1H)
ldi   t1,low(32768)   
out TCNT1L,t1		;  ,(TCNT1L)
ldi   t1,1<<TOV1	;     TOV1
out   TIFR,t1	    ;   TOV1
ldi   tim1,1	    ; 1   
Wait1:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV1	    ;   ,   - 
rjmp  Wait1	        ;   
ldi   t1,1<<TOV1	;     TOV1
out   TIFR,t1    	;   TOV1
dec   tim1
brne  Wait1	        ; 1  = 1,0 
ret
;**********************************************************************************

TIMER0_OVF:;   0,  

    wdr					 ;   
    in Save,SREG         ;    
    push t1
    push ZH
    push ZL
    ldi t1,Interval
	out TCNT0,t1         ;   T0
    ldi zl,Low(Katod<<1)  ;    
    ldi zh,High(Katod<<1)
	clr t1
    add zl,Ndisp         ;      
	adc zh,t1
	lpm                  ;   R0    
    or r0,Interm		 ; " " 
	out PORTD,r0         ;    
	
    ldi yl,Low(D0)       ;  SRAM - 
    ldi yh,High(D0)
    add yl,Ndisp         ;       
	ld t1,y              ;     SRAM - 
    out	PORTB,t1         ;   B   

inc Ndisp                ;   
    cpi Ndisp,4          ;    
	breq TA1             ; ,  Ndisp = 4
    pop ZL
    pop ZH
    pop t1
    out SREG,Save        ;    
reti
TA1:
clr Ndisp                ;     
	pop ZL
    pop ZH
    pop t1
    out SREG,Save        ;           
reti
;****************************************************************************
;      1-Wire
;****************************************************************************
Wait5us:	    ;    = 8,0 
ldi   tim1,10	;  
Wait501:
dec   tim1
brne  Wait501
nop
nop
nop
ret

Wait65us:	    ;    = 8,0 
ldi   tim1,170	;  
Wait565:
dec   tim1
brne  Wait565
nop
nop
nop
ret
	 
WaitML:	        ;    = 8,0 
rcall wait5us
dec   t2
brne  WaitML
ret

;**********************************************************************************
Microlan: ;   1-Wire   
;**********************************************************************************
ResML:    ;   

sbi DDRA,DQ       ; '' 
ldi t2,130
rcall WaitML      ;  700 
cbi DDRA,DQ       ; '' 
rcall Wait65us    ;  65
sbic PINA,DQ      ;   0  A
rjmp RM0          ;   ,  0
ldi t2,93
rcall WaitML      ;  500 
sbis PINA,DQ      ;   0  A
rjmp RM1
ret               
RM0: 
ret
RM1: 
ret

RdSlot:  ;  

sbi DDRA,DQ      ; '' 
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
cbi DDRA,DQ      ; '' 
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
ldi t2,2
rcall WaitML      ;  13 
sbis PINA,DQ      ;   0  A
rjmp RS0          ;  ,  1
sec               ;  , '1'
ldi t2,11
rcall WaitML      ;  60
ret
RS0:
clc               ;  , '0'
ldi t2,11
rcall WaitML      ;  60
ret

WrSlotL:  ;  '0'  

sbi DDRA,DQ      ; '' 
ldi t2,15
rcall WaitML     ;  80 
cbi DDRA,DQ      ; '' 
ret

WrSlotH:  ;  '1'  

sbi DDRA,DQ      ; '' 
rcall Wait5us
cbi DDRA,DQ      ; '' 
ldi t2,14
rcall WaitML     ;  75 
ret

Wr8ML:    ;  

ldi t1,8        ;  
WM0:
ror hexH          ;      
brcs WM1          ; ,  C=1
rcall WrSlotL     ;  '0'  
rjmp WM2
WM1:
rcall WrSlotH     ;  '1'  
WM2:
dec t1
brne WM0          ; ,   
ret

Wr1ML:    ;  

in t1,SREG      ;   
sbrs t1,0
rjmp WM5          ; ,  C=0
rcall WrSlotH     ;  '1'  
ret
WM5:
rcall WrSlotL     ;  '0'  
ret

Rd8ML:    ;  

ldi t1,8        ;  
WM6:
rcall RdSlot      ;  
ror hexH          ;      
dec t1
brne WM6          ; ,            
ret

Rd1ML:    ;  

rcall RdSlot      ;  
ret

;**********************************************************************************
ResML1:    ;   

sbi DDRA,DQ1       ; '' 
ldi t2,130
rcall WaitML      ;  700 
cbi DDRA,DQ1       ; '' 
rcall Wait65us    ;  65
sbic PINA,DQ1      ;   1  A
rjmp RM01          ;   ,  0
ldi t2,93
rcall WaitML      ;  500 
sbis PINA,DQ1      ;   1  A
rjmp RM11
ret               
RM01: 
ret
RM11: 
ret

RdSlot1:  ;  

sbi DDRA,DQ1      ; '' 
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
cbi DDRA,DQ1      ; '' 
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
ldi t2,2
rcall WaitML      ;  13 
sbis PINA,DQ1      ;   1  A
rjmp RS01          ;  ,  1
sec               ;  , '1'
ldi t2,11
rcall WaitML      ;  60
ret
RS01:
clc               ;  , '0'
ldi t2,11
rcall WaitML      ;  60
ret

WrSlotL1:  ;  '0'  

sbi DDRA,DQ1      ; '' 
ldi t2,15
rcall WaitML     ;  80 
cbi DDRA,DQ1      ; '' 
ret

WrSlotH1:  ;  '1'  

sbi DDRA,DQ1      ; '' 
rcall Wait5us
cbi DDRA,DQ1      ; '' 
ldi t2,14
rcall WaitML     ;  75 
ret

Wr8ML1:    ;  

ldi t1,8        ;  
WM01:
ror hexH          ;      
brcs WM11          ; ,  C=1
rcall WrSlotL1     ;  '0'  
rjmp WM21
WM11:
rcall WrSlotH1     ;  '1'  
WM21:
dec t1
brne WM01          ; ,   
ret

Wr1ML1:    ;  

in t1,SREG      ;   
sbrs t1,0
rjmp WM51          ; ,  C=0
rcall WrSlotH1     ;  '1'  
ret
WM51:
rcall WrSlotL1     ;  '0'  
ret

Rd8ML1:    ;  

ldi t1,8        ;  
WM61:
rcall RdSlot1      ;  
ror hexH          ;      
dec t1
brne WM61          ; ,            
ret

Rd1ML1:    ;  

rcall RdSlot1      ;  
ret
;**********************************************************************************
Thermometer: ;    DS18B20 (1 )

sbis PIND,6		    ;   ?
rjmp Term           ;  ,  
ldi t1,1			;      "1" 
sts SW0,t1
ldi t1,11			;      ""
sts SW1,t1
ldi t1,12			;      " "
sts SW2,t1
ldi t1,13			;      ""
sts SW3,t1
rcall Code_8_2      ;       
rcall Time1S        ;   1,0 
ldi t1,11			;      ""	 
sts SW0,t1
sts SW1,t1
sts SW2,t1
sts SW3,t1
Term:
rcall Code_8_2      ;       
rcall ConvTemp      ;  
rcall ReadTemp      ;  
ret

Termometr: ;      DS18B20 (1  2 )

rcall SignTemp     ;  
rcall ConvByte     ;   , DS18B20
rcall CalcTemp     ;    
rcall HexBCD       ;   BCD- ,   
rcall ConvByteD    ;   
rcall Code_8       ;       
ret

ConvTemp:  ;   

rcall ResML       ;    
ldi t1,$CC
mov hexH,t1       ;  
rcall Wr8ML       ;  
ldi t1,$44
mov hexH,t1       ;  
rcall Wr8ML       ;  
WD3:
rcall Rd1ML       ;  
brcs WD4          ; ,  C=1
rjmp WD3          ;    
WD4:
ret

ReadTemp:  ;  

rcall ResML       ;    
ldi t1,$CC
mov hexH,t1       ;  
rcall Wr8ML       ;  
ldi t1,$BE        ;   
mov hexH,t1
rcall Wr8ML       ;  
rcall Rd8ML       ;   
mov hexL,hexH     ;   
rcall Rd8ML       ;   
ret

Thermometer1: ;    DS18B20 (2 )

ldi t1,2			;      "2" 
sts SW0,t1
ldi t1,11			;      ""
sts SW1,t1
ldi t1,12			;      " "
sts SW2,t1
ldi t1,13			;      ""
sts SW3,t1
rcall Code_8_2      ;       
rcall Time1S        ;   1,0 
ldi t1,11			;      ""	 
sts SW0,t1
sts SW1,t1
sts SW2,t1
sts SW3,t1
rcall Code_8_2      ;       
rcall ConvTemp1     ;  
rcall ReadTemp1     ;  
ret

ConvTemp1:  ;   

rcall ResML1       ;    
ldi t1,$CC
mov hexH,t1        ;  
rcall Wr8ML1       ;  
ldi t1,$44
mov hexH,t1        ;  
rcall Wr8ML1       ;  
WD31:
rcall Rd1ML1       ;  
brcs WD41          ; ,  C=1
rjmp WD31          ;    
WD41:
ret

ReadTemp1:  ;  

rcall ResML1       ;    
ldi t1,$CC
mov hexH,t1        ;  
rcall Wr8ML1       ;  
ldi t1,$BE         ;   
mov hexH,t1
rcall Wr8ML1       ;  
rcall Rd8ML1       ;   
mov hexL,hexH      ;   
rcall Rd8ML1       ;   
ret

SignTemp:   ;  

mov t2,hexL     ;   
mov t1,hexH
bst  t1,7       ;     
brtc PosPlus0   ; ,   
com  t1         ;   
neg  t2         ;   
mov hexL,t2     ;   
mov hexH,t1
ldi t1,10       ;  '-',  
sts  SW0,t1
ret
PosPlus0:
ldi t1,11       ; '',  
sts  SW0,t1
ret

ConvByte:  ;   , DS18B20

mov t1,hexL       ;   
mov t2,hexH       ;   
swap t2           ;   
andi t2,$F0       ;   
swap t1           ;   
andi t1,$0F       ;   
or t2,t1          ;  
mov hexH,t2       ;   
mov t1,hexL
andi t1,$0F       ;    
mov hexL,t1       ;   
ret

ConvByteD:  ;       

mov t2,BCD0         ;   
andi BCD0,$F0       ;  
swap BCD0           ;   
cpi BCD0,0          ;  0
breq CB0
rjmp CB1            ;  > 0
CB0:
ldi t1,11           ;    ""
sts SW1,t1
rjmp CB2
CB1:
sts SW1,BCD0        ;     , 
CB2: 
andi t2,$0F         ;  
sts SW2,t2          ;     ,  
ret

CalcTemp: ;    

mov m0,hexL        ;   
ldi t1,0
mov m1,t1
ldi t1,$71         ;   625 = $271 = 0,0625*10000
mov m2,t1
ldi t1,2
mov m3,t1
ldi t1,0           ;        
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

ldi t1,$E8         ;   1000 = $3E8
mov m0,t1             
ldi t1,3
mov m1,t1

rcall DIV42

sts SW3,m4        ;     
ret

MUL42:          ;  
ldi  t1,0x10
MUL1:               ; , m3:m2 * m1:m0
mov  t2,m2          ;   m7:m6:m5:m4
ror  t2           
brcc  MUL2        
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
MUL2:
mov  t2,m7
ror  t2
mov  m7,t2
mov  t2,m6
ror  t2
mov  m6,t2
mov  t2,m5
ror  t2
mov  m5,t2
mov  t2,m4
ror  t2
mov  m4,t2
mov  t2,m3
ror  t2
mov  m3,t2
mov  t2,m2
ror  t2
mov  m2,t2
dec  t1
cpi  t1,0
brne MUL1
ret

DIV42:        ;  
ldi  t1,0x10
DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  t2,m4          ;   m5:m4
rol  t2
mov  m4,t2
mov  t2,m5
rol  t2
mov  m5,t2
mov  t2,m6
rol  t2
mov  m6,t2
mov  t2,m7
rol  t2
mov  m7,t2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  t2,m6
sbc  t2,m0
mov  m6,t2
mov  t2,m7
sbc  t2,m1
mov  m7,t2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
PER4:
dec  t1
cpi  t1,0
brne DCLK42
ret
;****************************************************************************
HexBCD:	        ; xx (Hex) -> 0abc (BCD)
rcall Div10	    ; hexH / 10, -  tmp1
mov   BCD0,t1	;   hexH, tmp1 =  1
rcall Div10
swap  t1      ;  2   
or    BCD0,t1 ;   2  1  BCD0
ret

Div10:	
clr  t1
lsl  hexH
rol  t1	    ;     10  
ldi  Cnt,7	    ;   7 
Loop10:
lsl  hexH	    ;     1 
rol  t1	    ;   tmp1
subi t1,10	; ;  > 10 ?
brlo HB1	    ; ,  
inc  hexH       ;    1
rjmp HB2
HB1:
subi t1,-10	;   
HB2:
dec  Cnt	    ;   
brne Loop10	
ret 
;****************************************************************************

SYMBOL:    ;     
;           HGFEDCBA,  .1
.db 0b00111111, 0b00000110   ; 0,1                            
.db 0b01011011, 0b01001111   ; 2,3                              
.db 0b01100110, 0b01101101   ; 4,5                              
.db 0b01111101, 0b00000111   ; 6,7                              
.db 0b01111111, 0b01101111   ; 8,9                              
.db 0b01000000, 0b00000000 ; "-","" 10,11
.db 0b01100011, 0b00111001 ; " ","" 12,13

Katod:     ;   
;     12,9,8,6-   ,   .1 
.db 0b00000001,0b00000010        
.db 0b00000100,0b00001000         

;******************************************************************************
ConvSegm:     ;      

ldi zl,Low(SYMBOL<<1)  ;    Z 
ldi zh,High(SYMBOL<<1) ;    
clr t1
add zl,t2           ;   ,     
adc zh,t1
lpm                    ;    -  r0
ret 

Code_8: ;       
         
lds t2,SW0        ;       ***1  ***
rcall ConvSegm    ;  
sts D0,r0         ;   ,  
lds t2,SW1        ;    
rcall ConvSegm    ;  
sts D1,r0         ;   ,  
lds t2,SW2        ;    
rcall ConvSegm    ;  
ldi t1,$80        ;    1
or  r0,t1         ;      
sts D2,r0         ;   ,  
lds t2,SW3        ;    
rcall ConvSegm    ;  
sts D3,r0         ;   ,  
ret

Code_8_2: ;          
         
lds t2,SW0        ;       ***1  ***
rcall ConvSegm    ;  
sts D0,r0         ;   ,  
lds t2,SW1        ;    
rcall ConvSegm    ;  
sts D1,r0         ;   ,  
lds t2,SW2        ;    
rcall ConvSegm    ;  
sts D2,r0         ;   ,  
lds t2,SW3        ;    
rcall ConvSegm    ;  
sts D3,r0         ;   ,  
ret        
;**********************************************************************************
.dseg
  
D0: .byte 1    ;   1- 
D1: .byte 1	   ;   2- 
D2: .byte 1    ;   3- 
D3: .byte 1	   ;   4- 


SW0: .byte 1   ;  1- 
SW1: .byte 1   ;  2- 
SW2: .byte 1   ;  3- 
SW3: .byte 1   ;  4- 


;********************************************************************************
.Exit


